#include "opencv2/opencv.hpp"

using namespace cv;


//detectando círculos
int main()
{
    Mat original = imread("chariot.jpg", 0);
    Mat gaussiana, saida;
    
    GaussianBlur(original,gaussiana,cv::Size(5,5),1.5);
    std::vector<cv::Vec3f> circles;
    
    HoughCircles(gaussiana, circles, CV_HOUGH_GRADIENT,
         2,   // acumulador de resolução
         50,  // distancia mínima entre círculos
         200, // canny threshold
         100, // votos
         25, 100); // raio mínimo e máximo
    
    saida = original.clone();
    
    std::vector<cv::Vec3f>::
             const_iterator itc= circles.begin();
    
    while (itc!=circles.end()) {
        circle(saida, Point((*itc)[0], (*itc)[1]), (*itc)[2], Scalar(255), 2);
        ++itc; 
    }
    
    imshow("original", original); waitKey(0);
    imshow("Hough Circle", saida); waitKey(0);
    
    return 0;
}

